Package net.sf.saxon.functions

## Class ExecutableFunctionLibrary

- java.lang.Object
- - net.sf.saxon.functions.ExecutableFunctionLibrary

- All Implemented Interfaces:
    `FunctionLibrary`

      public class ExecutableFunctionLibrary
      extends java.lang.Object
      implements FunctionLibrary

  An ExecutableFunctionLibrary is a function library that contains definitions of functions for use at run-time. Normally functions are bound at compile-time; however there are various situations in which the information is needed dynamically, for example (a) to support the XSLT function-available() call (in the pathological case where the argument is not known statically), (b) to allow functions to be called from saxon:evaluate(), (c) to allow functions to be called from a debugging breakpoint.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ExecutableFunctionLibrary​(Configuration config)` | Create the ExecutableFunctionLibrary

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addFunction​(UserFunction fn)` | Register a function with the function library
    `Expression` | `bind​(SymbolicName.F functionName, Expression[] staticArgs, StaticContext env, java.util.List<java.lang.String> reasons)` | Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
    `FunctionLibrary` | `copy()` | This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
    `Function` | `getFunctionItem​(SymbolicName.F functionName, StaticContext staticContext)` | Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.
    `boolean` | `isAvailable​(SymbolicName.F functionName)` | Test whether a function with a given name and arity is available
    `java.util.Iterator<UserFunction>` | `iterateFunctions()` | Iterate over all the functions defined in this function library.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.functions.FunctionLibrary

      `setConfiguration`

- - ### Constructor Detail

    - #### ExecutableFunctionLibrary

          public ExecutableFunctionLibrary​(Configuration config)

      Create the ExecutableFunctionLibrary
      Parameters:
        `config` - the Saxon configuration

  - ### Method Detail

    - #### addFunction

          public void addFunction​(UserFunction fn)

      Register a function with the function library
      Parameters:
        `fn` - the function to be registered

    - #### bind

          public Expression bind​(SymbolicName.F functionName,
                                 Expression[] staticArgs,
                                 StaticContext env,
                                 java.util.List<java.lang.String> reasons)

      Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.
      Specified by:
        `bind` in interface `FunctionLibrary`
      Parameters:
        `functionName` - The name of the function to be called
        `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm.
        `env` - the static evaluation context
        `reasons` - If no matching function is found by the function library, it may add a diagnostic explanation to this list explaining why none of the available functions could be used.
      Returns:
        An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name and arity.

    - #### getFunctionItem

          public Function getFunctionItem​(SymbolicName.F functionName,
                                          StaticContext staticContext)
                                   throws XPathException

      Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.

      This supports the function-lookup() function in XPath 3.0.

      Specified by:
        `getFunctionItem` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
        `staticContext` - the static context to be used by the function, in the event that it is a system function with dependencies on the static context
      Returns:
        if a function of this name and arity is available for calling, then a corresponding function item; or null if the function does not exist
      Throws:
        `XPathException` - in the event of certain errors, for example attempting to get a function that is private

    - #### isAvailable

          public boolean isAvailable​(SymbolicName.F functionName)

      Test whether a function with a given name and arity is available

      This supports the function-available() function in XSLT.

      Specified by:
        `isAvailable` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
      Returns:
        true if a function of this name and arity is available for calling

    - #### copy

          public FunctionLibrary copy()

      This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
      Specified by:
        `copy` in interface `FunctionLibrary`
      Returns:
        a copy of this function library. This must be an instance of the original class.

    - #### iterateFunctions

          public java.util.Iterator<UserFunction> iterateFunctions()

      Iterate over all the functions defined in this function library. The objects returned by the iterator are of class `UserFunction`
      Returns:
        an iterator delivering the `UserFunction` objects representing the user-defined functions in a stylesheet or query